<app-header-catalog
  [catalog]="'indicator'"
  [label]="label"
  [description]="description"
  [breadcrumb]="breadcrumb"
/>

<div [ngClass]="['indicator-page', jds.mt(30), jds.mb(70), jds.mx(0)]">
  <div [ngClass]="jds.container">
    <div [ngClass]="jds.row">
      <aside [ngClass]="[jds.col(3)]">
        <jds-bi-accordion
          #acc="jdsBiAccordion"
          [destroyOnHide]="true"
          [closeOthers]="false"
          [activeIds]="[
            'accordion-organization',
            'accordion-classification',
            'accordion-category'
          ]"
          colorScheme="blue"
        >
          <!-- Filter Organization Satu Data -->
          <jds-bi-panel
            id="accordion-organization"
            title="Organisasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listOrganizationSatuData(); as listOrgSatuData) {
                @switch (listOrgSatuData.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-organization
                      [data]="listOrgSatuData.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Classification Indicator -->
          <jds-bi-panel
            id="accordion-classification"
            title="Klasifikasi"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listClassificationIndicator(); as listClass) {
                @switch (listClass.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-classification-indicator
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>

          <!-- Filter Category Indicator -->
          <jds-bi-panel
            id="accordion-category"
            title="Kategori"
          >
            <ng-template jdsBiPanelContent>
              @if (vm.listIndicatorCategory(); as listIndicatorCategory) {
                @switch (listIndicatorCategory.status) {
                  @case ('loading') {
                    <app-skeleton-filter />
                  }
                  @case ('success') {
                    <app-filter-category-indicator
                      [data]="listIndicatorCategory.data.list"
                      [filter]="vm.filterCategory()"
                      (filterChange)="vm.handleFilterCategory($event)"
                    />
                  }
                }
              }
            </ng-template>
          </jds-bi-panel>
        </jds-bi-accordion>

        <div [ngClass]="[jds.card, jds.bg('#0753a6'), jds.mt(20)]">
          <div [ngClass]="[jds.cardBody]">
            <p [ngClass]="[jds.fs(14), jds.text('white'), jds.mb(20)]">
              Mengakses beberapa indikator sekaligus dalam satu waktu?
            </p>
            <a
              [ngClass]="[
                jds.button,
                jds.buttonOutlineWhite,
                jds.d('inline-flex')
              ]"
              [routerLink]="['/indicator/download']"
            >
              <span [ngClass]="[jds.me(28)]">Unduh Indikator</span>
              <jds-bi-icon name="chevron-right" />
            </a>
          </div>
        </div>
      </aside>

      <div [ngClass]="[jds.col(9)]">
        <!-- Search Catalog -->
        <div [ngClass]="[jds.mb(16)]">
          <app-search-catalog
            [catalog]="'indicator'"
            [search]="vm.filterSearch()"
            (searchChange)="vm.handleFilterSearch($event)"
          />
        </div>

        <div
          [ngClass]="[
            jds.d('flex'),
            jds.alignItems('center'),
            jds.justifyContent('between'),
            jds.mb(24)
          ]"
        >
          <!-- Suggestion Catalog -->
          @if (vm.listIndicator(); as listIndicator) {
            @switch (listIndicator.status) {
              @case ('loading') {
                <div class="wrapper-skeleton">
                  <ngx-skeleton-loader
                    [theme]="{
                      width: '25%',
                      'border-radius': '0',
                      height: '22px',
                      'margin-bottom': '0'
                    }"
                  />
                </div>
              }
              @case ('success') {
                @if (listIndicator.data.list.length > 0) {
                  <span [ngClass]="[jds.fs(14)]">
                    <strong>
                      {{
                        listIndicator.data.pagination.total_items
                          | number: '1.0-0' : 'id'
                      }}
                    </strong>
                    Indikator ditemukan
                  </span>
                } @else {
                  <span [ngClass]="[jds.fs(14)]">
                    Indikator tidak ditemukan
                  </span>
                }
              }
            }
          }

          <!-- Sort Catalog -->
          <app-sort-catalog
            [catalog]="'indicator'"
            [sort]="vm.filterSort()"
            (sortChange)="vm.handleFilterSort($event)"
          />
        </div>

        <!-- Quick Access Catalog -->
        @if (vm.hasFilterQuickAccess()) {
          <div [ngClass]="[vm.hasFilterQuickAccess() ? jds.mb(16) : '']">
            <div [ngClass]="jds.d('flex')">
              <div [ngClass]="[jds.minW(100), jds.leading(32)]">
                <span>Filter Aktif: </span>
              </div>
              <div>
                <!-- Quick Access Organization -->
                @if (vm.listOrganizationSatuData(); as listOrgSatuData) {
                  @if (listOrgSatuData.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'organization'"
                      [data]="listOrgSatuData.data.list"
                      [filter]="vm.filterOrganization()"
                      (filterChange)="vm.handleFilterOrganization($event)"
                    />
                  }
                }

                <!-- Quick Access Classification -->
                @if (vm.listClassificationIndicator(); as listClass) {
                  @if (listClass.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'classification-indicator'"
                      [data]="listClass.data.list"
                      [filter]="vm.filterClassification()"
                      (filterChange)="vm.handleFilterClassification($event)"
                    />
                  }
                }

                <!-- Quick Access Category -->
                @if (vm.listIndicatorCategory(); as listIndicatorCategory) {
                  @if (listIndicatorCategory.isSuccess) {
                    <app-quick-access-catalog
                      [type]="'category-indicator'"
                      [data]="listIndicatorCategory.data.list"
                      [filter]="vm.filterCategory()"
                      (filterChange)="vm.handleFilterCategory($event)"
                    />
                  }
                }

                <button
                  [size]="'sm'"
                  [ngClass]="[jds.me(8), jds.mb(8)]"
                  [variant]="'ghost'"
                  [colorScheme]="colorScheme"
                  (click)="vm.handleFilterClear()"
                  jdsBiButton
                  type="button"
                >
                  Hapus Semua
                </button>
              </div>
            </div>
          </div>
        }

        <!-- List Catalog Indicator -->
        @if (vm.listIndicator(); as listIndicator) {
          @switch (listIndicator.status) {
            @case ('loading') {
              <app-skeleton-catalog />
            }
            @case ('success') {
              @if (listIndicator.isFetching) {
                <app-skeleton-catalog />
              } @else if (listIndicator.data.list.length > 0) {
                @for (item of listIndicator.data.list; track item.id) {
                  <app-list-indicator
                    [isAction]="false"
                    [data]="item"
                  />
                }

                <jds-bi-pagination
                  [colorScheme]="colorScheme"
                  [perPageItems]="perPageItems"
                  [pagination]="listIndicator.data.pagination"
                  [perPage]="vm.filterPerPage()"
                  [page]="vm.filterCurrentPage()"
                  (filterPerPage)="vm.handleFilterPerPage($event)"
                  (filterPage)="vm.handleFilterCurrentPage($event)"
                />
              } @else {
                @if (vm.hasFilterSearch()) {
                  <app-list-empty type="dataset">
                    <h6>Maaf, hasil pencarian tidak ditemukan.</h6>
                    <p>
                      Indikator yang Anda cari tidak ditemukan atau terjadi
                      kesalahan penulisan kata kunci.
                    </p>
                  </app-list-empty>
                } @else {
                  <app-list-empty type="dataset">
                    <h6>Maaf, belum ada Indikator yang dapat diakses.</h6>
                    <p>
                      Mohon coba kembali di lain waktu untuk mendapatkan
                      Indikator yang Anda cari.
                    </p>
                  </app-list-empty>
                }
              }
            }
          }
        }
      </div>
    </div>
  </div>
</div>
